// DestinationDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MapEdit.h"
#include "classes.h"
#include "DestinationDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDestinationDlg dialog


CDestinationDlg::CDestinationDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDestinationDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDestinationDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CDestinationDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDestinationDlg)
	DDX_Control(pDX, IDC_CHECK_FLAG, m_Chk_Flag);
	DDX_Control(pDX, IDC_COMBO_DIR, m_Combo_Dir);
	DDX_Control(pDX, IDC_COMBO_TYPE, m_Combo_Type);
	DDX_Control(pDX, IDC_LIST_DEST, m_ListBox);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDestinationDlg, CDialog)
	//{{AFX_MSG_MAP(CDestinationDlg)
	ON_LBN_SELCHANGE(IDC_LIST_DEST, OnListBoxSelect)
	ON_BN_CLICKED(IDC_ADD, OnAdd)
	ON_BN_CLICKED(IDC_REMOVE, OnRemove)
	ON_BN_CLICKED(IDC_APPLY, OnApply)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_SEEK, OnSeek)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDestinationDlg message handlers

BOOL CDestinationDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	if(tempmap.m_hDC == NULL) {
		tempmap.CreateCompatibleDC(GetDC());
		SelectObject((HDC)tempmap, CreateCompatibleBitmap((HDC)*GetDC(), 256, 256));
	}
	if(crosshair.m_hDC == NULL) {
		crosshair.CreateCompatibleDC(GetDC());
		CBitmap bmp;
		bmp.LoadBitmap(IDB_CROSSHAIR);
		crosshair.SelectObject(bmp);
	}

	// TODO: Add extra initialization here
	if(request_seek) {
		request_seek = false;

		sel_dest = seek_sel;

		dest.entries[sel_dest].x = seek_x;
		dest.entries[sel_dest].y = seek_y;

		SelectDest(sel_dest);

		ApplyChanges();
	}
	else
		SelectDest(sel_dest);

	RefreshListBox();

	m_ListBox.SetTabStops(20);

	return FALSE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDestinationDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here

	// hmm
	// instead of doing this, we should first paint a slightly larger region
	// into a temporary buffer, and then paint that onto our little preview
	// pane, adjusting it for precise coordinates, and adding a nifty crosshair.


	// find our destination's tile location
	dc.Draw3dRect(CRect(68, 222, 68+132, 222+68), GetSysColor(COLOR_3DSHADOW), GetSysColor(COLOR_3DHILIGHT));
	dc.Draw3dRect(CRect(69, 223, 69+130, 223+66), GetSysColor(COLOR_3DDKSHADOW), GetSysColor(COLOR_3DLIGHT));

	if(dest.entries[sel_dest].type == DEST_DOOR) {
		int tile_x = dest.entries[sel_dest].x / 4;
		int tile_y = dest.entries[sel_dest].y / 4;
		int rem_x  = dest.entries[sel_dest].x - (tile_x*4);
		int rem_y  = dest.entries[sel_dest].y - (tile_y*4);
		tile_x -= 4;
		tile_y -= 4;

		int px = (4*32) + (rem_x*8);
		int py = (4*32) + (rem_y*8);

		for(int x = 0; x < 8; x++) {
			for(int y = 0; y < 8; y++) {
				// draw a map tile
				int cy = tile_y+y;
				int cx = tile_x+x;

				int tile = (cy<0||cy>319||cx<0||cx>255)?0:*map_tiles[cy][cx];
				int lset = (cy<0||cy>319||cx<0||cx>255)?0:*lsets[cy][cx];
				int gset = (cy<0||cy>319||cx<0||cx>255)?0:*gsets[(cy)/4][(cx)/8];
				tempmap.BitBlt(x*32,y*32,32,32,&tilesets[gset],tile*32,lset*32,SRCCOPY);
			}
		}
		tempmap.Draw3dRect(CRect(px, py, px+8, py+8),RGB(255,0,0),RGB(255,0,0));
		dc.BitBlt(70,224,128,64,&tempmap,(2*32)+(rem_x*8)+4,(3*32)+(rem_y*8)+4,SRCCOPY);
		dc.BitBlt(70,224,128,64,&crosshair,0,0,SRCAND);
	}
	else {
		dc.FillSolidRect(70, 224, 128, 64, GetSysColor(COLOR_3DFACE));
	}

	// Do not call CDialog::OnPaint() for painting messages
}




void CDestinationDlg::RefreshListBox()
{
	m_ListBox.SetRedraw(FALSE);	// turn drawing off

	m_ListBox.ResetContent();

	for(int i = 0; i < dest.num_dest; i++) {
		CString str;

		str.Format("%d:	", i);

		switch(dest.entries[i].type) {
		case DEST_DOOR:
			str.Format("%d:	Door	-	(%d, %d)", i, dest.entries[i].x, dest.entries[i].y);
			break;
		case DEST_OBJECT: case DEST_PERSON:
			str.Format("%d:	Object -	%s", i, FormatSNESAdr(dest.entries[i].pointer));
			break;
		case DEST_SWITCH:
			str.Format("%d:	Switch -	%s", i, FormatSNESAdr(dest.entries[i].eventFlag));
			break;
		}
		m_ListBox.AddString(str);
	}

	m_ListBox.SetRedraw(TRUE);

	m_ListBox.SetCurSel(sel_dest);
}

void CDestinationDlg::DisplayDestData(int destination)
{
	SetDlgItemText(IDC_EDIT_POINTER, FormatSNESAdr(dest.entries[destination].pointer));
	SetDlgItemText(IDC_EDIT_FLAG, FormatSNESAdr(dest.entries[destination].eventFlag));
	m_Chk_Flag.SetCheck(dest.entries[destination].checkFlag);

	SetDlgItemInt(IDC_EDIT_X, dest.entries[destination].x);
	SetDlgItemInt(IDC_EDIT_Y, dest.entries[destination].y);
	SetDlgItemInt(IDC_EDIT_STYLE, dest.entries[destination].style);

	m_Combo_Dir.SetCurSel(dest.entries[destination].direction);

	m_Combo_Dir.EnableWindow(FALSE);
	m_Chk_Flag.EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_X)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_Y)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_STYLE)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDIT_FLAG)->EnableWindow(FALSE);
	GetDlgItem(IDC_SEEK)->EnableWindow(FALSE);

	switch(dest.entries[destination].type) {
	case DEST_DOOR:
		m_Combo_Type.SetCurSel(0);

		m_Combo_Dir.EnableWindow();
		m_Chk_Flag.EnableWindow();
		GetDlgItem(IDC_EDIT_X)->EnableWindow();
		GetDlgItem(IDC_EDIT_Y)->EnableWindow();
		GetDlgItem(IDC_EDIT_STYLE)->EnableWindow();
		GetDlgItem(IDC_EDIT_FLAG)->EnableWindow();
		GetDlgItem(IDC_SEEK)->EnableWindow();

		break;
	case DEST_OBJECT: case DEST_PERSON:
		m_Combo_Type.SetCurSel(1);

		break;
	case DEST_SWITCH:
		m_Combo_Type.SetCurSel(2);

		m_Chk_Flag.EnableWindow();
		GetDlgItem(IDC_EDIT_FLAG)->EnableWindow();

		break;
	}

	SetDlgItemText(IDC_EDIT_DADR, FormatSNESAdr(dest.entries[destination].address));

	Invalidate(FALSE);
}


void CDestinationDlg::OnListBoxSelect() 
{
	SelectDest(m_ListBox.GetCurSel());
}



void CDestinationDlg::OnAdd() 
{
	// TODO: Add your control notification handler code here
	AddDestination(&dest, DEST_DOOR, 0, 0, 0, 0, 0, false, 0);

	//RefreshListBox();
	InsertDestString(dest.num_dest-1, -1);

	SelectDest(dest.num_dest-1);
}

void CDestinationDlg::OnRemove() 
{
	// TODO: Add your control notification handler code here
	int destination = m_ListBox.GetCurSel();

	RemoveDestination(&dest, destination, areas);

	m_ListBox.SetRedraw(FALSE);

	for(int i = 0; i < dest.num_dest; i++)
		InsertDestString(i, -1);

	for(i = 0; i < dest.num_dest+1; i++) {
		m_ListBox.DeleteString(0);
		m_ListBox.SetCurSel(destination);
	}

	if(destination >= dest.num_dest) destination = dest.num_dest - 1;

	SelectDest(destination);
	DisplayDestData(destination);

	m_ListBox.SetRedraw(TRUE);
	Invalidate(FALSE);
}

void CDestinationDlg::OnApply() 
{
	ApplyChanges();
}

void CDestinationDlg::InsertDestString(int i, int loc)
{
	CString str;

	switch(dest.entries[i].type) {
	case DEST_DOOR:
		str.Format("%d:	Door	-	(%d, %d)", i, dest.entries[i].x, dest.entries[i].y);
		break;
	case DEST_OBJECT: case DEST_PERSON:
		str.Format("%d:	Object -	%s", i, FormatSNESAdr(dest.entries[i].pointer));
		break;
	case DEST_SWITCH:
		str.Format("%d:	Switch -	%s", i, FormatSNESAdr(dest.entries[i].eventFlag));
		break;
	}
	m_ListBox.InsertString(loc, str);
}



void CDestinationDlg::SelectDest(int destination)
{
	sel_dest = destination;
	m_ListBox.SetCurSel(destination);
	DisplayDestData(destination);
}

void CDestinationDlg::ApplyChanges()
{
	switch(m_Combo_Type.GetCurSel()) {
	case 0:	// door
		dest.entries[sel_dest].type = DEST_DOOR;
		break;
	case 1:	// object
		dest.entries[sel_dest].type = DEST_OBJECT;
		break;
	case 2:	// switch
		dest.entries[sel_dest].type = DEST_SWITCH;
		break;
	}

	dest.entries[sel_dest].x = GetDlgItemInt(IDC_EDIT_X);
	dest.entries[sel_dest].y = GetDlgItemInt(IDC_EDIT_Y);
	dest.entries[sel_dest].style = GetDlgItemInt(IDC_EDIT_STYLE);

	dest.entries[sel_dest].direction = m_Combo_Dir.GetCurSel();

	CString str;

	GetDlgItemText(IDC_EDIT_POINTER, str);
	dest.entries[sel_dest].pointer = DeformatSNESAdr(str);

	GetDlgItemText(IDC_EDIT_FLAG, str);
	dest.entries[sel_dest].eventFlag = DeformatSNESAdr(str);

	dest.entries[sel_dest].checkFlag = m_Chk_Flag.GetCheck()!=0;

	// refresh list box
	m_ListBox.DeleteString(sel_dest);
	InsertDestString(sel_dest, sel_dest);
	SelectDest(sel_dest);
}


void CDestinationDlg::OnSeek() 
{
	// First, save our data
	ApplyChanges();

	request_seek = true;
	seek_sel = sel_dest;

	seek_x = dest.entries[sel_dest].x;
	seek_y = dest.entries[sel_dest].y;

	EndDialog(42);
}



void CDestinationDlg::OnOK() 
{
	ApplyChanges();
	CDialog::OnOK();
}
