// DoorDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MapEdit.h"
#include "DoorDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

int grad = 0;
int incr = 15;
int speed = 40;

CString txt = "Warning!";

BOOL edit_ready = FALSE;

/////////////////////////////////////////////////////////////////////////////
// CDoorDlg dialog


CDoorDlg::CDoorDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDoorDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDoorDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

}


void CDoorDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDoorDlg)
	DDX_Control(pDX, IDC_DESTSPIN, m_DestSpin);
	DDX_Control(pDX, IDC_COMBO_TYPE, m_Combo_Type);
	DDX_Control(pDX, IDC_LIST_DEST, m_ListBox);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDoorDlg, CDialog)
	//{{AFX_MSG_MAP(CDoorDlg)
	ON_CBN_SELCHANGE(IDC_COMBO_TYPE, OnSelectType)
	ON_BN_CLICKED(IDC_EDITDEST, OnBtnEditDest)
	ON_WM_PAINT()
	ON_EN_CHANGE(IDC_EDIT_DEST, OnEditDest)
	ON_LBN_SELCHANGE(IDC_LIST_DEST, OnSelectDest)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDoorDlg message handlers

BOOL CDoorDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// Only create once
	if(ropewin.m_hWnd == NULL) ropewin.Create(IDD_DOOR_ROPEDLG, this);
	if(escwin.m_hWnd == NULL) escwin.Create(IDD_DOOR_ESCDLG, this);
	if(stairwin.m_hWnd == NULL) stairwin.Create(IDD_DOOR_STAIRDLG, this);

	if(tempmap.m_hDC == NULL) {
		tempmap.CreateCompatibleDC(GetDC());
		SelectObject((HDC)tempmap, CreateCompatibleBitmap((HDC)*GetDC(), 256, 256));
	}
	if(buf.m_hDC == NULL) {
		buf.CreateCompatibleDC(GetDC());
		SelectObject((HDC)buf, CreateCompatibleBitmap((HDC)*GetDC(), 128, 64));
	}
	if(tbuf.m_hDC == NULL) {
		tbuf.CreateCompatibleDC(GetDC());

		// create bitmap surface
		SelectObject((HDC)tbuf, CreateCompatibleBitmap((HDC)*GetDC(), 128, 64));

		// set font
		CFont font;
		font.CreatePointFont(140,"Arial Black");
		tbuf.SelectObject(font);

		// set text characteristics
		tbuf.SetBkMode(TRANSPARENT);
		tbuf.SetTextColor(RGB(255,0,0));
		tbuf.FillSolidRect(0,0,256,64,RGB(255,255,255));
	}
	if(crosshair.m_hDC == NULL) {
		crosshair.CreateCompatibleDC(GetDC());
		CBitmap bmp;
		bmp.LoadBitmap(IDB_CROSSHAIR);
		crosshair.SelectObject(bmp);
	}

	m_DestSpin.SetRange(0, dest.num_dest-1);

	// Display data and stuff
	RefreshListBox();
	DisplayDoorData();

	edit_ready = TRUE;

	SetTimer(0, speed, NULL);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDoorDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	if(door.flags == DEST_DOOR || door.flags == DEST_SWITCH || door.flags == DEST_OBJECT || door.flags == DEST_PERSON) {
		int ypos = 140;
		int xpos = 53;
		dc.Draw3dRect(CRect(xpos, ypos, xpos+132, ypos+68), GetSysColor(COLOR_3DSHADOW), GetSysColor(COLOR_3DHILIGHT));
		dc.Draw3dRect(CRect(xpos+1, ypos+1, xpos+1+130, ypos+1+66), GetSysColor(COLOR_3DDKSHADOW), GetSysColor(COLOR_3DLIGHT));

		if(dest.entries[door.destindex].type == DEST_DOOR) {
			int tile_x = dest.entries[door.destindex].x / 4;
			int tile_y = dest.entries[door.destindex].y / 4;
			int rem_x  = dest.entries[door.destindex].x - (tile_x*4);
			int rem_y  = dest.entries[door.destindex].y - (tile_y*4);
			tile_x -= 4;
			tile_y -= 4;

			int px = (4*32) + (rem_x*8);
			int py = (4*32) + (rem_y*8);

			for(int x = 0; x < 8; x++) {
				for(int y = 0; y < 8; y++) {
					// draw a map tile
					int cy = tile_y+y;
					int cx = tile_x+x;

					int tile = (cy<0||cy>319||cx<0||cx>255)?0:*map_tiles[cy][cx];
					int lset = (cy<0||cy>319||cx<0||cx>255)?0:*lsets[cy][cx];
					int gset = (cy<0||cy>319||cx<0||cx>255)?0:*gsets[(cy)/4][(cx)/8];
					tempmap.BitBlt(x*32,y*32,32,32,&tilesets[gset],tile*32,lset*32,SRCCOPY);
				}

			}
			tempmap.Draw3dRect(CRect(px, py, px+8, py+8),RGB(255,0,0),RGB(255,0,0));

			buf.BitBlt(0, 0, 128, 64, &tempmap, (2*32)+(rem_x*8)+4, (3*32)+(rem_y*8)+4, SRCCOPY);
			buf.BitBlt(0, 0, 128, 64, &crosshair, 0, 0, SRCAND);

			dc.BitBlt(xpos+2, ypos+2, 128, 64, &buf, 0, 0, SRCCOPY);
		}
		else {
			dc.FillSolidRect(xpos+2, ypos+2, 128, 64, GetSysColor(COLOR_3DFACE));
		}

		// check for a mismatch
		int f = door.flags;
		int t = dest.entries[door.destindex].type;

		if(f != t && !((f == DEST_OBJECT || f == DEST_PERSON) && (t == DEST_OBJECT)))  {
			tbuf.SetTextColor(RGB(255, grad, grad));
			tbuf.FillSolidRect(0,0,256,64,RGB(255,255,255));
			tbuf.TextOut(0,0,txt);

			buf.FillSolidRect(0, 0, 128, 64, RGB(255,255,255));
			buf.BitBlt(5, 38, 100, 32, &tbuf, 0, 0, SRCAND);

			dc.BitBlt(55, 142, 128, 64, &buf, 0, 0, SRCAND);
		}
	}

	// Do not call CDialog::OnPaint() for painting messages
}

void CDoorDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if(door.flags == DEST_DOOR || door.flags == DEST_SWITCH || door.flags == DEST_OBJECT || door.flags == DEST_PERSON) {
		grad+=incr;

		if(grad >= 255) {
			grad = 0;
			if(txt == "Mismatch!") {
				txt = "Warning!";
			}
			else {
				txt = "Mismatch!";
			}
		}

		InvalidateRect(CRect(53,140,53+128,140+64), FALSE);
	}

	CDialog::OnTimer(nIDEvent);
}


void CDoorDlg::OnSelectType() 
{
	door.flags = m_Combo_Type.GetCurSel();
	DisplayDoorData();
}


void CDoorDlg::OnOK()
{
	if(GetDlgItemInt(IDC_EDIT_DEST) >= dest.num_dest)
		AfxMessageBox("ERROR: Invalid door destination.\n\nDestination index greater than number of actual destinations.\nFor those who haven't figured it out already, this is a bad thing.");
	else {
		ApplyChanges();
		edit_ready = FALSE;
		KillTimer(0);
		CDialog::OnOK();
	}
}


void CDoorDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	edit_ready = FALSE;
	KillTimer(0);
	CDialog::OnCancel();
}


void CDoorDlg::OnBtnEditDest() 
{
	if(GetDlgItemInt(IDC_EDIT_DEST) >= dest.num_dest)
		AfxMessageBox("ERROR: Invalid door destination.\n\nDestination index greater than number of actual destinations.\nFor those who haven't figured it out already, this is a bad thing.");
	else {
		ApplyChanges();
		edit_ready = FALSE;
		KillTimer(0);
		EndDialog(42);
	}
}


void CDoorDlg::RefreshListBox()
{
	m_ListBox.SetRedraw(FALSE);	// turn drawing off

	m_ListBox.SetTabStops(20);

	m_ListBox.ResetContent();

	for(int i = 0; i < dest.num_dest; i++) {
		CString str;

		str.Format("%d:	", i);

		switch(dest.entries[i].type) {
		case DEST_DOOR:
			str.Format("%d:	Door	-	(%d, %d)", i, dest.entries[i].x, dest.entries[i].y);
			break;
		case DEST_OBJECT: case DEST_PERSON:
			str.Format("%d:	Object -	%s", i, FormatSNESAdr(dest.entries[i].pointer));
			break;
		case DEST_SWITCH:
			str.Format("%d:	Switch -	%s", i, FormatSNESAdr(dest.entries[i].eventFlag));
			break;
		}
		m_ListBox.AddString(str);
	}

	m_ListBox.SetRedraw(TRUE);

	m_ListBox.SetCurSel(door.destindex);
}



void CDoorDlg::DisplayDoorData()
{
	m_Combo_Type.SetCurSel(door.flags);
	SetDlgItemInt(IDC_EDIT_X, door.x);
	SetDlgItemInt(IDC_EDIT_Y, door.y);

	ropewin.ShowWindow(SW_HIDE);
	escwin.ShowWindow(SW_HIDE);
	stairwin.ShowWindow(SW_HIDE);
	GetDlgItem(IDC_EDIT_DEST)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_DESTSPIN)->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_EDITDEST)->EnableWindow(FALSE);
	m_ListBox.EnableWindow(FALSE);

	switch(door.flags) {
	case DEST_SWITCH:
	case DEST_DOOR:
	case DEST_OBJECT:
	case DEST_PERSON:
		GetDlgItem(IDC_EDIT_DEST)->ShowWindow(SW_SHOWNORMAL);
		GetDlgItem(IDC_DESTSPIN)->ShowWindow(SW_SHOWNORMAL);
		SetDlgItemInt(IDC_EDIT_DEST, door.destindex);

		GetDlgItem(IDC_EDITDEST)->EnableWindow(TRUE);
		m_ListBox.EnableWindow(TRUE);
		m_ListBox.SetCurSel(door.destindex);
		break;

	case DEST_ROPE:
		ropewin.ShowWindow(SW_SHOWNORMAL);
		if(door.ropetype == 0)
			ropewin.m_Sel_Ladder.SetCheck(1);
		else
			ropewin.m_Sel_Rope.SetCheck(1);
		break;

	case DEST_STAIR:
		stairwin.ShowWindow(SW_SHOWNORMAL);

		stairwin.m_Sel_UL.SetCheck(door.direction == 0);
		stairwin.m_Sel_UR.SetCheck(door.direction == 1);
		stairwin.m_Sel_DL.SetCheck(door.direction == 2);
		stairwin.m_Sel_DR.SetCheck(door.direction == 3);

	case DEST_ESCALATOR:
		escwin.ShowWindow(SW_SHOWNORMAL);

		if(door.is_esc_end) {
			escwin.m_Chk_End.SetCheck(1);
			escwin.m_Sel_UL.EnableWindow(FALSE);
			escwin.m_Sel_UR.EnableWindow(FALSE);
			escwin.m_Sel_DL.EnableWindow(FALSE);
			escwin.m_Sel_DR.EnableWindow(FALSE);
		}
		else {
			escwin.m_Chk_End.SetCheck(0);
			escwin.m_Sel_UL.EnableWindow();
			escwin.m_Sel_UR.EnableWindow();
			escwin.m_Sel_DL.EnableWindow();
			escwin.m_Sel_DR.EnableWindow();

			escwin.m_Sel_UL.SetCheck(door.direction == 0);
			escwin.m_Sel_UR.SetCheck(door.direction == 1);
			escwin.m_Sel_DL.SetCheck(door.direction == 2);
			escwin.m_Sel_DR.SetCheck(door.direction == 3);
		}

		break;
	}
}



void CDoorDlg::ApplyChanges()
{
	door.flags = m_Combo_Type.GetCurSel();
	door.x = GetDlgItemInt(IDC_EDIT_X);
	door.y = GetDlgItemInt(IDC_EDIT_Y);

	switch(door.flags) {
	case DEST_SWITCH:
	case DEST_DOOR:
	case DEST_OBJECT:
	case DEST_PERSON:
		door.destindex = GetDlgItemInt(IDC_EDIT_DEST);
		break;
	case DEST_ROPE:
		door.ropetype = ropewin.m_Sel_Rope.GetCheck();
		break;
	case DEST_STAIR:
		if(stairwin.m_Sel_UL.GetCheck()) door.direction = 0;
		if(stairwin.m_Sel_UR.GetCheck()) door.direction = 1;
		if(stairwin.m_Sel_DL.GetCheck()) door.direction = 2;
		if(stairwin.m_Sel_DR.GetCheck()) door.direction = 3;
		break;
	case DEST_ESCALATOR:
		if(escwin.m_Sel_UL.GetCheck()) door.direction = 0;
		if(escwin.m_Sel_UR.GetCheck()) door.direction = 1;
		if(escwin.m_Sel_DL.GetCheck()) door.direction = 2;
		if(escwin.m_Sel_DR.GetCheck()) door.direction = 3;
		if(escwin.m_Chk_End.GetCheck()) door.is_esc_end = 1;
		else door.is_esc_end = 0;
	}
	DisplayDoorData();
}

void CDoorDlg::OnEditDest() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	if(edit_ready) {
		int newdest = GetDlgItemInt(IDC_EDIT_DEST);
		if(newdest < dest.num_dest) {
			door.destindex = newdest;

			if(m_ListBox.m_hWnd != NULL) {
				m_ListBox.SetRedraw(FALSE);
				m_ListBox.SetCurSel(newdest);
				m_ListBox.SetRedraw(TRUE);
			}

			Invalidate(FALSE);
		}
	}
}


void CDoorDlg::OnSelectDest() 
{
	// TODO: Add your control notification handler code here
	door.destindex = m_ListBox.GetCurSel();
	DisplayDoorData();
	m_ListBox.SetFocus();
}



