// SpriteDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MapEdit.h"
#include "SpriteDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSpriteDlg dialog


CSpriteDlg::CSpriteDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSpriteDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSpriteDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CSpriteDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSpriteDlg)
	DDX_Control(pDX, IDC_SPIN_SPR, m_Spin);
	DDX_Control(pDX, IDC_COMBO_TYPE, m_Combo_Type);
	DDX_Control(pDX, IDC_COMBO_DIR, m_Combo_Dir);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSpriteDlg, CDialog)
	//{{AFX_MSG_MAP(CSpriteDlg)
	ON_WM_PAINT()
	ON_EN_CHANGE(IDC_EDIT_SPRITE, OnChangeEditSprite)
	ON_EN_CHANGE(IDC_EDIT_TPTNUM, OnChangeEditTptNum)
	ON_BN_CLICKED(IDC_APPLY_TPT, OnApplyTPT)
	ON_CBN_SELCHANGE(IDC_COMBO_TYPE, OnSelectType)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSpriteDlg message handlers

BOOL CSpriteDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	DisplaySpriteData();

	m_Spin.SetRange(0, 463);
	m_Spin.SetPos(tpt[sprite.tptNum].sprite);

	m_Spin.SetBuddy(GetDlgItem(IDC_EDIT_SPRITE));
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CSpriteDlg::DisplaySpriteData()
{
	if(!user_edited)
		SetDlgItemInt(IDC_EDIT_TPTNUM, sprite.tptNum);
	
	CString str;
	str.Format("TPT Entry Information: entry #%d", sprite.tptNum);
	SetDlgItemText(IDC_GROUPBOX, str);

	SetDlgItemInt(IDC_EDIT_X, sprite.x);
	SetDlgItemInt(IDC_EDIT_Y, sprite.y);

	SetDlgItemInt(IDC_EDIT_SPRITE, tpt[sprite.tptNum].sprite);
	SetDlgItemText(IDC_EDIT_POINTER, FormatSNESAdr(tpt[sprite.tptNum].pointer));
	SetDlgItemText(IDC_EDIT_ITEMPOINTER, FormatSNESAdr(tpt[sprite.tptNum].itempointer));
	SetDlgItemText(IDC_EDIT_FLAG, FormatSNESAdr(tpt[sprite.tptNum].flag));
	SetDlgItemInt(IDC_EDIT_FLAGUSE, tpt[sprite.tptNum].flaguse);

	SetDlgItemInt(IDC_EDIT_MOVEMENT1, tpt[sprite.tptNum].movement1);
	SetDlgItemInt(IDC_EDIT_MOVEMENT2, tpt[sprite.tptNum].movement2);

	SetDlgItemInt(IDC_EDIT_ITEM, tpt[sprite.tptNum].item);
	
	m_Combo_Dir.SetCurSel(tpt[sprite.tptNum].dir);
	m_Combo_Type.SetCurSel(tpt[sprite.tptNum].type-1);

	if(tpt[sprite.tptNum].type == 2) {
		GetDlgItem(IDC_EDIT_ITEMPOINTER)->EnableWindow(FALSE);
		GetDlgItem(IDC_EDIT_ITEM)->EnableWindow(TRUE);
	}
	else {
		GetDlgItem(IDC_EDIT_ITEMPOINTER)->EnableWindow(TRUE);
		GetDlgItem(IDC_EDIT_ITEM)->EnableWindow(FALSE);
	}
}

void CSpriteDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here

	int spr = sprConv[tpt[sprite.tptNum].sprite];

	int x = 27;
	int y = 100;

	int w = sprite_gfx[spr].width * 8;
	int h = sprite_gfx[spr].height * 8;

	dc.FillSolidRect(27, 100, 64, 80, GetSysColor(COLOR_3DSHADOW));
	sprite_gfx[spr].Draw(&dc, 27 + 32-(w/2), 100 + 40-(h/2), pal[sprite_gfx[spr].palette]);
	
	// Do not call CDialog::OnPaint() for painting messages
}

void CSpriteDlg::OnChangeEditSprite() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	int spr = GetDlgItemInt(IDC_EDIT_SPRITE);

	if(spr < 464) {
		tpt[sprite.tptNum].sprite = spr;
		Invalidate(FALSE);
	}
	
}

void CSpriteDlg::ApplyChanges()
{
	sprite.tptNum = GetDlgItemInt(IDC_EDIT_TPTNUM);
	sprite.x = GetDlgItemInt(IDC_EDIT_X);
	sprite.y = GetDlgItemInt(IDC_EDIT_Y);
}

void CSpriteDlg::ApplyTPTChanges()
{
	int i = sprite.tptNum;

	tpt[i].sprite = GetDlgItemInt(IDC_EDIT_SPRITE);

	CString str;

	GetDlgItemText(IDC_EDIT_POINTER, str);
	tpt[i].pointer = DeformatSNESAdr(str);

	GetDlgItemText(IDC_EDIT_ITEMPOINTER, str);
	tpt[i].itempointer = DeformatSNESAdr(str);

	GetDlgItemText(IDC_EDIT_FLAG, str);
	tpt[i].flag = DeformatSNESAdr(str);
	tpt[i].flaguse = GetDlgItemInt(IDC_EDIT_FLAGUSE);

	tpt[i].movement1 = GetDlgItemInt(IDC_EDIT_MOVEMENT1);
	tpt[i].movement2 = GetDlgItemInt(IDC_EDIT_MOVEMENT2);

	tpt[i].item = GetDlgItemInt(IDC_EDIT_ITEM);

	tpt[i].dir = m_Combo_Dir.GetCurSel();
	tpt[i].type = m_Combo_Type.GetCurSel()+1;
}


void CSpriteDlg::OnChangeEditTptNum() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	int tptnum = GetDlgItemInt(IDC_EDIT_TPTNUM);
	if(tptnum < 1583) {
		sprite.tptNum = tptnum;

		user_edited = TRUE;
		DisplaySpriteData();
		user_edited = FALSE;
	}
}

void CSpriteDlg::OnApplyTPT() 
{
	ApplyTPTChanges();
}

void CSpriteDlg::OnOK() 
{
	ApplyChanges();
	ApplyTPTChanges();

	CDialog::OnOK();
}

void CSpriteDlg::OnSelectType() 
{
	tpt[sprite.tptNum].type = m_Combo_Type.GetCurSel()+1;
	DisplaySpriteData();
}
